#include <stdio.h>
#include <stdlib.h>
#include "datastructure.h"

void insertListElement(sCD *newNode)
{
    sCD *stack = first;
    if (newNode)
        if (!first)
            first = last = newNode;
        else if (listSort(first, newNode) >= 0)
        {
            first->previous = newNode;
            newNode->next = first;
            first = newNode;
        }
        else if (listSort(last, newNode) <= 0)
        {
            newNode->previous = last;
            last = last->next = newNode;
        }
        else
        {

            while (stack)
            {
                if (listSort(stack, newNode) > 0)
                {
                    newNode->previous = stack;
                    newNode->next = stack->next;
                    stack->next->previous = newNode;
                    stack->next = newNode;
                    break;
                }
                stack = stack->next;
            }
        }
}

void deleteNode(sCD** head_ref, sCD* del)
{
    /* base case */
    if (*head_ref == NULL || del == NULL)
        return;
  
    /* If node to be deleted is head node */
    if (*head_ref == del)
    
        *head_ref = del->next;
  
    /* Change next only if node to be deleted is NOT the last node */
    if (del->next != NULL)
        del->next->previous = del->previous;
  
    /* Change previous only if node to be deleted is NOT the first node */
    if (del->previous != NULL)
        del->previous->next = del->next;
  
    /* Finally, free the memory occupied by del*/
    free(del);
    return;
}

void printVoward()
{
    int gesamtLaufZeit = 0;
    sCD *CDData = first;
    while (CDData)
    {
        putchar('\n');
        printf("Titel              : %s\n", (CDData)->title);
        if ((CDData)->artist)
            printf("artist             : %s\n", (CDData)->artist);
        printf("Erscheinungsjahr   : %i\n", (CDData)->publicationYear);
        printf("Anzahl Lieder      : %i\n", (CDData)->numberOfSongs);
        puts("Lieder");
        for (unsigned int j = 0; j < (CDData)->numberOfSongs; j++)
        {
            listOneSong(j, CDData);
            gesamtLaufZeit += durationConverter((CDData)->Songs[j].duration);
        }
        addTime(gesamtLaufZeit);
        gesamtLaufZeit = 0;
        CDData = CDData->next;
    }
}

void printReverse()
{
    int gesamtLaufZeit = 0;
    sCD *CDData = last;
    while (CDData)
    {
        putchar('\n');
        printf("Titel              : %s\n", (CDData)->title);
        if ((CDData)->artist)
            printf("artist             : %s\n", (CDData)->artist);
        printf("Erscheinungsjahr   : %i\n", (CDData)->publicationYear);
        printf("Anzahl Lieder      : %i\n", (CDData)->numberOfSongs);
        puts("Lieder");
        for (unsigned int j = 0; j < (CDData)->numberOfSongs; j++)
        {
            listOneSong(j, CDData);
            gesamtLaufZeit += durationConverter((CDData)->Songs[j].duration);
        }
        addTime(gesamtLaufZeit);
        gesamtLaufZeit = 0;
        CDData = CDData->previous;
    }
}